/******************** (C) COPYRIGHT 2009 e-Design Co.,Ltd. *********************
* File Name: file.c      Author: bure      Hardware: DS0201V1.1    Version: V1.0
*******************************************************************************/
#include "msd.h"
#include "File.h"
#include "Function.h"
#include "Calculate.h"
#include "Lcd.h"

unsigned int DiskStart, Hidden_Sec, Root_Addr, ClusterNum, File_Addr; 
unsigned short RsvdSecCnt, FAT_Size16, FAT_Size32; 
unsigned short SecPerClus, DirFliePtr, DirFlieSec, DirSecNum, MaxNum;

/*******************************************************************************
 MSD_FAT_Info: ȡSD̻Ϣ   룺NONE   ֵ0x00=ɹ
*******************************************************************************/
char FAT_Info(void)
{
  char Rvalue = 0xFF;
  DiskStart =0;
  Rvalue=MSD_ReadBlock(SectorBuff, 0, 512);
  if(Rvalue!=0) return Rvalue;
  if((SectorBuff[0] != 0xEB)&&(SectorBuff[0] != 0xE9)){
    DiskStart =(SectorBuff[0x1C9]<<24)+(SectorBuff[0x1C8]<<16)+(SectorBuff[0x1C7]<<8)+(SectorBuff[0x1C6]);
    Rvalue=MSD_ReadBlock(SectorBuff, DiskStart<<9, 512);
    if(Rvalue!=0) return Rvalue;
  }
  SecPerClus = SectorBuff[0x0D];
  RsvdSecCnt =(SectorBuff[0x0F]<<8)+(SectorBuff[0x0E]);//0x0001
  FAT_Size16 =(SectorBuff[0x17]<<8)+(SectorBuff[0x16]);//0x001F
  Hidden_Sec =(SectorBuff[0x1F]<<24)+(SectorBuff[0x1E]<<16)+(SectorBuff[0x1D]<<8)+(SectorBuff[0x1C]);
  FAT_Size32 =(SectorBuff[0x25]<<8)+(SectorBuff[0x24]);
  if(FAT_Size16==0)
    Root_Addr =(DiskStart + RsvdSecCnt + 2*FAT_Size32)*512;
  else
    Root_Addr =(DiskStart + RsvdSecCnt + 2*FAT_Size16)*512; //(61+1+1F+1F)*512=14000
  return 0;
}
/*******************************************************************************
 Open_File: ָļ   룺ļŲ   ֵ0x00=ɹ 
*******************************************************************************/
char Open_File(unsigned char *n)
{
  char Rvalue = 0xFF; 
  unsigned short i, SectorCnt;
  DirFliePtr =0;
  DirFlieSec =0;
  if(FAT_Size16==0)
    DirSecNum =0;
  else
    DirSecNum = 0x20;

  Rvalue=MSD_ReadBlock(SectorBuff, Root_Addr, 512);
  if(Rvalue!=0){
    return 0xFF;
  }
  for(SectorCnt=0;SectorCnt<DirSecNum;++SectorCnt){
    Rvalue=MSD_ReadBlock(SectorBuff, Root_Addr + SectorCnt*512, 512);
    if(Rvalue!=0){ 
    return Rvalue;
    }
    for(i=0; i<512; i+=32){
      if((SectorBuff[i]=='F')&&(SectorBuff[i+1]=='I')&&(SectorBuff[i+2]=='L')&&(SectorBuff[i+3]=='E')){
        if((SectorBuff[i+8]=='D')&&(SectorBuff[i+9]=='A')&&(SectorBuff[i+10]=='T')){
          if((SectorBuff[i+4]==*n)&&(SectorBuff[i+5]==*(n+1))&&(SectorBuff[i+6]==*(n+2))){
            DirFliePtr = i;
            DirFlieSec = SectorCnt;
            if(FAT_Size16 ==0) SectorBuff[i+0x15]=SectorBuff[i+0x14]=0;
            ClusterNum =((SectorBuff[i+0x15]<<24)+(SectorBuff[i+0x14]<<16)+(SectorBuff[i+0x1B]<<8)+(SectorBuff[i+0x1A]));
            File_Addr = Root_Addr +(DirSecNum +(ClusterNum -2)*SecPerClus)*512;
            return 0;
          }
        }
      }
    }
  }
  return 0xFF;
}
/*******************************************************************************
 Read_File: ȡָļ   룺NONE   ֵ0x00=ɹ 
*******************************************************************************/
char Read_File(void)
{
  return MSD_ReadBlock(SectorBuff, File_Addr, 512);
}
/*******************************************************************************
 Write_File: дָļд˳   룺NONE   ֵ0x00=ɹ 
*******************************************************************************/
char Write_File(void)
{
  char Rvalue = 0xFF;
  Rvalue = MSD_WriteBlock(SectorBuff, File_Addr, 512);
  if(Rvalue!=0) return Rvalue;
//  Rvalue=MSD_ReadBlock(SectorBuff, Root_Addr + DirFlieSec*512, 512);
//  if(Rvalue!=0) return Rvalue;
//  SectorBuff[DirFliePtr+0x16] = SectorBuff[DirFliePtr+0x17] =0;
//  SectorBuff[DirFliePtr+0x19] = MaxNum +1; 
//  SectorBuff[DirFliePtr+0x19] = 1; 
//  Rvalue = MSD_WriteBlock(SectorBuff, Root_Addr + DirFlieSec*512, 512);
  return Rvalue;
}

/*******************************************************************************
 Write_File: дָļд˳   룺NONE   ֵ0x00=ɹ 
******************************************************************************
char Save_Parameters(void)
{
  SectorBuff = 302;
  for(i=0; i<40; ++i) *SectorBuff++ = (char*)Item_Index[i];
  for(i=0; i<2; ++i)  *SectorBuff++ = (char*)vt;
  for(i=0; i<1; ++i)  *SectorBuff++ = (char*)Hide_vs;
  for(i=0; i<4; ++i)  *SectorBuff++ = (char*)Cycle;
}*/
/*
//                  memcpy( SectorBuff+302, (char*)Item_Index, 100);   
struct parameters
{
unsigned short Item_Index[20];
unsigned short vt, v0, v1, v2, t0, t1, t2;    
unsigned char  Hide_vs, Hide_vt, Hide_v0, Hide_v1, Hide_v2;
unsigned char  Hide_t1, Hide_t2, Hide_Ref, Item;
          int  Frequency, Cycle, Duty, Vram, Vavg, Vpp, DCV; 
};
*/

/*******************************************************************************

SDݣ0x00      Ϊ 0xEB  0xE9 ʾͬʱҲ߼
                0x01C6~0x01C9 4ֽΪ߼ʼλãλں  DiskStart    

ݣ0x000B,0x000C 2ֽڸֽڳȣλں    SectorsLen   
                       0x000D 1ֽڸÿص2ݣ SecPerClus   
                0x000E,0x000F 2ֽڸ̵ıλں    RsvdSecCnt    
FAT16       0x0016,0x0017 2ֽ FATռõλں    FAT_Size16   FAT32ʱֵΪ 0x0000
                0x001C~0x001F 4ֽڸ̵λں    Hidden_Sec    
FAT32       0x0024,0x0025 2ֽ FATռõλں    FAT_Size32   

FATĳ   FAT_LEN   = FAT_Size16 SectorsLen           
FAT1ʼ  FAT1_Sect = DiskStart + RsvdSecCnt           
FAT2ʼ  FAT2_Sect = FAT1_Sect + FAT_Size16           
Ŀ¼ʼRoot_Sect = FAT2_Sect + FAT_Size16           
Ŀ¼ʼַRoot_Addr = Root_Sect SectorsLen   

Ŀ¼ݣRoot_Addr + 0x0020 ʼÿĿ¼Ϊ 0x20
                FAT16Ŀ¼ռ SecPerRoot = 0x20 
                FAT32Ŀ¼ռ SecPerRoot = 0x01  SecPerClus 

Ŀ¼еݣ0x00~0x07 8ֽļ   
                0x08~0x0A 3ֽչ
                0x16,0x17 2ֽ޸ʱ䣨 = Hour << 11 + Minute << 5 + Second >> 1 
                0x18,0x19 2ֽ޸ڣ = Year - 1980 << 9 + Month << 5 + Day 
FAT32       0x14,0x15 ļʼغBit 16~31λֽںCluster_Hi
FAT16       0x1A,0x1B ļʼغBit  0~15λֽںCluster     0x12E5
                0x1C-0x1F 4ֽڵļֽڳ λں
                  
ļʼַ  File_Addr = Root_Sect + SecPerRoot +Cluster -0x02SecPerClus Sectors_LEN

*******************************************************************************/
/******************************** END OF FILE *********************************/

