/******************** (C) COPYRIGHT 2009 e-Design Co.,Ltd. *********************
* File Name: HW_V1_config.c   Author: bure   Hardware: DS0201V1.1  Version: V1.0
*******************************************************************************/
#include "Function.h"
#include "stm32f10x_it.h"
#include "stm32f10x_systick.h"
#include "HW_V1_Config.h"
#include "usb_lib.h"
#include "msd.h"

unsigned char Key_Status_Last =0;

ErrorStatus HSEStartUpStatus;

/*******************************************************************************
*     : Set_System    ˵   : ϵͳʱӼԴʼ
*******************************************************************************/
void Set_System(void)
{
  RCC_DeInit();               
  RCC_HSEConfig(RCC_HSE_ON);  
  HSEStartUpStatus = RCC_WaitForHSEStartUp();
  if(HSEStartUpStatus == SUCCESS)
  {
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);
    FLASH_SetLatency(FLASH_Latency_2);    //Flash 2 wait state
    RCC_HCLKConfig(RCC_SYSCLK_Div1);      //HCLK = SYSCLK 
    RCC_PCLK2Config(RCC_HCLK_Div1);       //PCLK2 = HCLK 
    RCC_PCLK1Config(RCC_HCLK_Div2);       //PCLK1 = HCLK/2
    RCC_ADCCLKConfig(RCC_PCLK2_Div4);     //ADCCLK = PCLK2/4 = 18MHz
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);  //PLLCLK = 72 MHz
    RCC_PLLCmd(ENABLE);
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET){}
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);
    while(RCC_GetSYSCLKSource()!=0x08){}
  }
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA, ENABLE);

  RCC_APB2PeriphClockCmd(
    RCC_APB2Periph_ADC1  | RCC_APB2Periph_ADC2  | RCC_APB2Periph_GPIOA | 
    RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD | 
    RCC_APB2Periph_GPIOE | RCC_APB2Periph_AFIO  | RCC_APB2Periph_TIM1, ENABLE);
  
  RCC_APB1PeriphClockCmd(
    RCC_APB1Periph_TIM2 | RCC_APB1Periph_TIM3 | RCC_APB1Periph_TIM4 | 
    RCC_APB1Periph_SPI2, ENABLE);

  RCC_USBCLKConfig(RCC_USBCLKSource_PLLCLK_1Div5);     //USBCLK = 48MHz
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_USB, ENABLE);  //Enable USB clock

}
/*******************************************************************************
*     : NVIC_Configuration   ˵   : жʸʼ
*******************************************************************************/
void NVIC_Configuration(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;
//  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0000);
  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x4000);

  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);

  NVIC_InitStructure.NVIC_IRQChannel = USB_LP_CAN_RX0_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  
  NVIC_InitStructure.NVIC_IRQChannel = USB_HP_CAN_TX_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  /* enabling TIM1 interrupt */
  NVIC_InitStructure.NVIC_IRQChannel=TIM1_CC_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  /* enabling TIM3 interrupt */
  NVIC_InitStructure.NVIC_IRQChannel=TIM3_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  /* enabling DMA interrupt */
  NVIC_InitStructure.NVIC_IRQChannel=DMAChannel2_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  /*SysTick
  NVIC_SystemHandlerPriorityConfig(SystemHandler_SysTick, 1, 0);
  SysTick_ITConfig(ENABLE);
  SysTick_CounterCmd(SysTick_Counter_Enable);*/
}

/*******************************************************************************
*     : GPIO_Config   ˵   : GPIO˿ڳʼ
*******************************************************************************/
void GPIO_Config(void)
{
  GPIOA_CRL = 0x88888080;  /* GPIOA Bit0-7 ״̬
                |||||||+----- Nib0  Ain   ģ
                ||||||+------ Nib1  NC    
                |||||+------- Nib2  Vbat  ģ  
                ||||+-------- Nib3  NC      
                |||+--------- Nib4  KP      
                ||+---------- Nib5  KL      
                |+----------- Nib6  KU      
                +------------ Nib7  KR    */ 
  GPIOA_CRH = 0x8884488B;  /* GPIOA Bit8-15 ״̬
                |||||||+----- Nib8  MCO   
                ||||||+------ Nib9  NC    
                |||||+------- Nib10 NC      
                ||||+-------- Nib11 D-      
                |||+--------- Nib12 D+      
                ||+---------- Nib13 TMS     
                |+----------- Nib14 TCK     
                +------------ Nib15 TDI   */  
  GPIOA_ODR = 0x0FFFF;
  
  GPIOB_CRL = 0x88888411;  /* GPIOB Bit0-7 ״̬
                |||||||+----- Nib0  A     
                ||||||+------ Nib1  D     
                |||||+------- Nib2  BT1     
                ||||+-------- Nib3  TDO     
                |||+--------- Nib4  TRST    
                ||+---------- Nib5  NC      
                |+----------- Nib6  NC      
                +------------ Nib7  NC    */  
  GPIOB_CRH = 0xBBB1B488;  /* GPIOB Bit8-15 ״̬
                |||||||+----- Nib8  NC    
                ||||||+------ Nib9  NC    
                |||||+------- Nib10 Vusb    
                ||||+-------- Nib11 V0      
                |||+--------- Nib12 SDCS    
                ||+---------- Nib13 SCK     
                |+----------- Nib14 MISO    
                +------------ Nib15 MOSI  */  
  GPIOB_ODR = 0x0FFFF;
  
  GPIOC_CRL = 0x84118881;  /* GPIOB Bit0-7 ״̬
                |||||||+----- Nib0  nCLS  
                ||||||+------ Nib1  NC    
                |||||+------- Nib2  NC      
                ||||+-------- Nib3  NC      
                |||+--------- Nib4  C       
                ||+---------- Nib5  B       
                |+----------- Nib6  NC      
                +------------ Nib7  NC    */  
  GPIOC_CRH = 0x88888884;  /* GPIOB Bit8-15 ״̬
                |||||||+----- Nib8  NC    
                ||||||+------ Nib9  NC    
                |||||+------- Nib10 NC      
                ||||+-------- Nib11 NC      
                |||+--------- Nib12 NC      
                ||+---------- Nib13 NC      
                |+----------- Nib14 NC      
                +------------ Nib15 NC    */  
  GPIOC_ODR = 0x0FFFF;
  
  GPIOD_CRL = 0x38338838;  /* GPIOB Bit0-7 ״̬
                |||||||+----- Nib0  NC    
                ||||||+------ Nib1  RS    
                |||||+------- Nib2  NC      
                ||||+-------- Nib3  NC      
                |||+--------- Nib4  nRD     
                ||+---------- Nib5  nWR     
                |+----------- Nib6  NC      
                +------------ Nib7  nCS   */  
  GPIOD_CRH = 0x888B8884;  /* GPIOB Bit8-15 ״̬
                |||||||+----- Nib8  NC    
                ||||||+------ Nib9  KD    
                |||||+------- Nib10 SDDT    
                ||||+-------- Nib11 KM      
                |||+--------- Nib12 Fout    
                ||+---------- Nib13 NC      
                |+----------- Nib14 NC      
                +------------ Nib15 NC    */  
  GPIOD_ODR = 0x0FF7F;
  
  GPIOE_CRL = 0x33333333;   //Bit0-7  LCD_DB0-7 
  GPIOE_CRH = 0x33333333;   //Bit8-15 LCD_DB8-15
 
  AFIO_MAPR = 0x00001200;  /* AFIOӳĴ Bit0-31 ״̬
                ||||||++----- Ϊλֵ
                |||||+------- Bit9   TIM2_CH3_CH4 ӳ PB10,PB11
                ||||+-------- Bit12  TIM4_CH1     ӳ PD12
                ++++--------- Ϊλֵ */ 
}

/*******************************************************************************
* Function Name  : SPI_Config   ˵   : SPIʼ
*******************************************************************************/
void SPI_Config(void)
{
  SPI_InitTypeDef   SPI_InitStructure;
   
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4;
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  SPI_InitStructure.SPI_CRCPolynomial = 7;
  SPI_Init(SPI2, &SPI_InitStructure);  // SPI2 Config
  
  SPI_Cmd(SPI2, ENABLE);               // SPI2 enable 
}
/*******************************************************************************
*  : DMA_configuration  ˵ : DMAͨ1ʼ,ADC䱣
*******************************************************************************/
void DMA_Configuration(void)
{
  DMA_ISR = 0x00000000;/*DMAж״̬ĴͨIFCRӦλ
              |||||||+---GIF1 =0ͨ1ûTEHTTC¼ȫжϱ־
              |||||||+---TCIF1=0ͨ1ûжϱ־
              |||||||+---HTIF1=0ͨ1û봫жϱ־
              |||||||+---TEIF1=0ͨ1ûжϱ־
              ||||||+----ͨ2жϱ־
              ||||++-----ͨ3жϱ־
              ||||++-----ͨ4жϱ־
              |||+-------ͨ5жϱ־
              ||+--------ͨ6жϱ־ 
              ||+--------ͨ7жϱ־ 
              +----------*/
  DMA_IFCR= 0x00000000;/*DMAжϱ־Ĵû
              |||||||+---CGIF1 =1ͨ1TEHTTC¼ȫжϱ־
              |||||||+---CTCIF1=1ͨ1Ĵжϱ־
              |||||||+---CHTIF1=1ͨ1İ봫жϱ־
              |||||||+---CTEIF1=1ͨ1Ĵжϱ־
              ||||||+----ͨ2жϱ־
              ||||++-----ͨ3жϱ־
              ||||++-----ͨ4жϱ־
              |||+-------ͨ5жϱ־
              ||+--------ͨ6жϱ־ 
              ||+--------ͨ7жϱ־ 
              +----------*/
  DMA_CCR1=  0x00003580;/*0011 0101 1000 0000  
               ||||       |||| |||| |||| |||+--EN = 0ͨرգ1ͨ
               ||||       |||| |||| |||| ||+---TCIE=0ж
               ||||       |||| |||| |||| |+----HTIE=0ֹ봫ж
               ||||       |||| |||| |||| +-----TEIE=0ֹж
               ||||       |||| |||| |||+-------DIR =0ݴ䷽򣨴
               ||||       |||| |||| ||+--------CIRC=0ִѭ
               ||||       |||| |||| |+---------PINC=0ִַģʽ 
               ||||       |||| |||| +----------MINC=1ִд洢ַģʽ
               ||||       |||| ||++------------PSIZE=0116λݿ
               ||||       |||| ++--------------MSIZE=0116λ洢ݿ
               ||||       ||++-----------------PL=11ͨȼ
               ||||       |+-------------------MEM2MEM=0Ǵ洢洢ģʽ
               ++++-------+--------------------*/

  DMA_CNDTR1=0x00001000;          //DMAͨ1Ĵ(4096*2 Bytes)  
  DMA_CPAR1 = ADC1_DR_ADDR;       //DMAͨ1ݼĴַ 
  DMA_CMAR1 =(u32)&Scan_Buffer[0];//DMAͨ1ԴĿĴ洢ַ
  DMA_CCR1 |= 0x00000001;         // EN = 1DMAͨ1 
}
/*******************************************************************************
*     : ADC_configuration  ˵  : ADCʼɺԶDMA
*******************************************************************************/
void ADC_Configuration(void)
{
  ADC2_CR1 =0x00000000;
  ADC1_CR1 =0x00000000;/*
              ||||||++---AWDCH[4:0]ģ⿴Źͨѡλ 
              ||||||+----=000EOCAWDJEOCж
              |||||+-----Nib8_SCAN=0ʹɨģʽ
              ||||++-----ָλֵ
              |||+-------DUALMOD=0ģʽ
              ||+--------ͨעͨģ⿴Ź 
              ++---------*/
  ADC2_CR2 =0x00100000;
  ADC1_CR2 =0x00100100;/*
              |||||||+---ADON=0رADCת/У׼=1ADCת
              |||||||+---CONT=01תģʽ
              |||||||+---CAL=0=1A/DУʼ׼У׼λӲ
              |||||||+---RSTCAL=0=1ʼУ׼ĴУ׼λӲ
              ||||||+----
              |||||+-----ALIGN=0 & DMA=1ҶʹDMAģʽ
              ||||+------
              |||+-------=0000ͨʹöʱ1CC1¼ת=1110SWSTART
              ||+--------=1ʹⲿźת 
              ++---------*/
  ADC2_SQR1=0x00000000;
  ADC1_SQR1=0x00000000;/*ADCмĴ 1
              ||++++++---SQ13-16=00000תе13-16תͨ(5Bits*4)
              ++---------*/
  ADC2_SQR3 =0x00000004;
  ADC1_SQR3 =0x00000000;/*ADCмĴ 3
               ||||||++---SQ1=00000תеĵ1תͨı(0)
               +++++++----SQ2-6=00000תе2-6תͨ(5Bits*5)
               +----------*/
  ADC2_SMPR2=0x00001000;
  ADC1_SMPR2=0x00000000;/*ADCʱĴ 1   
               |||||||+---SMP01=001(3Bits)ʹͨ00Ĳʱ 1.5T   
               ||||+------SMP04=001(3Bits)ʹͨ04Ĳʱ 7.5T
               |+++++++---SMP11-17=000(3Bits*7)ͨ11-17Ĳʱ 1.5T
               ++---------*/
  ADC1_CR2 |=0x00000001; 
  ADC2_CR2 |=0x00000001;       //ADON=1ADC1ADC2
  ADC1_CR2 |=0x00000008; 
  while(ADC1_CR2 & 0x00000008);//ʼADC1У׼Ĵ
  ADC2_CR2 |=0x00000008; 
  while(ADC2_CR2 & 0x00000008);//ʼADC2У׼Ĵ
  ADC1_CR2 |=0x00000004; 
  while(ADC1_CR2 & 0x00000004);//ADC1У׼
  ADC2_CR2 |=0x00000004; 
  while(ADC2_CR2 & 0x00000004);//ADC2У׼
}
/*******************************************************************************
*  : Timer_configuration    ˵ : ϵͳʱʼ
*******************************************************************************/
void Timer_Configuration(void)
{
//---------------TIM1ڶʱADC-------------------
  Set_Base(Item_Index[2]);  
  TIM1_CR1 = 0x0094;/*0000 0000 1001 0100  
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA 
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ 
                      |||| |||| |||+--------DIR=1¼
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM1_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM1_RCR = 0x0000;/*0000 0000 0000 0001  
                      |||| |||| ++++ ++++---ڱضģʽ£PWMڵĿ+1
                      ++++-++++-------------*/
  TIM1_CCER =0x0001;/*0000 0000 0000 0001  
                      |||| |||| |||| |||+---CC1E=1OC1źӦ
                      |||| |||| |||| ||+----CC1P=0OC1ߵƽЧ
                      |||| |||| |||| |+-----CC1NE=0OC1Nֹ
                      |||| |||| |||| +------CC1NP=0OC1NߵƽЧ
                      ++++-++++-++++--------CC2CC3CC4Ϊλֵ*/
  TIM1_CCMR1=0x0078;/*0000 0000 0111 1100  
                      |||| |||| |||| ||++---CC1S=00CC1ͨΪ
                      |||| |||| |||| |+-----OC1FE=1Ƚ1 ʹܣ
                      |||| |||| |||| +------OC1PE=1Ƚ1Ԥװʹ 
                      |||| |||| |+++--------0C1M=111PWMģʽ2
                      |||| |||| +-----------OC1CE=0OC1REF ETRFӰ
                      ++++-++++-------------CC2ͨΪλֵ*/
  TIM1_BDTR =0x8000;/*1000 0000 0000 0000  
                      |+++-++++-++++-++++---λֲ 
                      +---------------------MOE=0ʹ*/
  TIM1_DIER =0x4200;/*0100 0011 0000 0000  DMAжʹܼĴ
                       |     ||        +----CC1IE=0/Ƚ1ж
                       |     |+-------------UDE=1µDMA
                       |     +--------------CC1DE=1/Ƚ1DMA
                       +--------------------TDE=1DMA*/
  TIM1_CR1 |=0x0001;//CEN=1ʹTIMER1 

//-----------------TIM2_CH4PWMYͨƫƵѹֵ-------------------  
  TIM2_PSC =0;  
  TIM2_ARR =3839;              //72MHz/3840=18.75KHz 
  Set_Y_Pos(v0);  
  TIM2_CR1 = 0x0084;/*0000 0000 1000 0100  
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA 
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ 
                      |||| |||| |||+--------DIR=0ϼ
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM2_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM2_CCER =0x3000;/*0011 0000 0000 0000  
                      |||| ++++-++++-++++---CC1CC2CC3Ϊλֵ
                      |||+------------------CC4E=1OC4źӦ
                      ||+-------------------CC4P=1OC4͵ƽЧ
                      |+--------------------CC4NE=0OC4Nֹ
                      +---------------------CC4NP=0OC4NߵƽЧ*/
  TIM2_CCMR2=0x7C00;/*0111 1100 0000 0000  
                      |||| |||| ++++-++++---CC3ͨΪλֵ
                      |||| ||++-------------CC4S=00CC4ͨΪ
                      |||| |+---------------OC4FE=1Ƚ4 ʹܣ
                      |||| +----------------OC4PE=1Ƚ4Ԥװʹ 
                      |+++------------------0C4M=111PWMģʽ2
                      +---------------------OC4CE=0OC4REF ETRFӰ*/
  TIM2_CR1 |=0x0001;//CEN=1ʹTIMER2 

//-----------------TIM3ϵͳʱ-------------------  
  TIM3_PSC  =9; 
  TIM3_ARR  =7199;  //1mS =PSC+1ARR+1/72MHz/2uS
  TIM3_CCR1 =3600; //ȣռձȣ50%
  TIM3_CR1 = 0x0084;/*0000 0000 1000 0100  
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA 
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ 
                      |||| |||| |||+--------DIR=0ϼ
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM3_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM3_DIER =0x0002;/*0000 0000 0000 0010  DMAжʹܼĴ
                             |         +----CC1IE=1/Ƚ1ж
                             +--------------CC1DE=1/Ƚ1DMA*/
  TIM3_CR1 |=0x0001;//CEN=1ʹTIMER3 

//------------------TIM4_CH1ѡƵʵı׼----------------------
  TIM4_PSC = 7;
  TIM4_ARR = Fout_ARR[Item_Index[11]];        //
  TIM4_CCR1 = (Fout_ARR[Item_Index[11]]+1)/2; //0.5mSռձԼ50%
  TIM4_CR1 = 0x0084;/*0000 0000 1000 0100  
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA 
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ 
                      |||| |||| |||+--------DIR=0ϼ
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM3_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM4_CCER =0x0001;/*0000 0000 0000 0001  
                      |||| |||| |||| |||+---CC1E=1OC1źӦ
                      |||| |||| |||| ||+----CC1P=0OC1ߵƽЧ
                      |||| |||| |||| |+-----CC1NE=0OC1Nֹ
                      |||| |||| |||| +------CC1NP=0OC1NߵƽЧ
                      ++++-++++-++++--------CC2CC3CC4Ϊλֵ*/
  TIM4_CCMR1=0x0078;/*0000 0000 0111 1100  
                      |||| |||| |||| ||++---CC1S=00CC1ͨΪ
                      |||| |||| |||| |+-----OC1FE=1Ƚ1 ʹܣ
                      |||| |||| |||| +------OC1PE=1Ƚ1Ԥװʹ 
                      |||| |||| |+++--------0C1M=111PWMģʽ2
                      |||| |||| +-----------OC1CE=0OC1REF ETRFӰ
                      ++++-++++-------------CC2ͨΪλֵ*/
  TIM4_CR1 |=0x0001;//CEN=1ʹTIMER4 
}
/*******************************************************************************
* KeyScan    ˵ȡ  أɨ룬KeyBuff=
*******************************************************************************/
char KeyScan(void)
{
  char Key_Status_Now=0, KeyCode=0;
  
  if((~GPIOA_IDR) & 0x0010) Key_Status_Now |= 0x01; //KEY_PLAY_ON
  if((~GPIOD_IDR) & 0x0800) Key_Status_Now |= 0x02; //KEY_MENU_ON
  if((~GPIOA_IDR) & 0x0040) Key_Status_Now |= 0x04; //KEY_UP_ON
  if((~GPIOD_IDR) & 0x0200) Key_Status_Now |= 0x08; //KEY_DOWN_ON
  if((~GPIOA_IDR) & 0x0020) Key_Status_Now |= 0x10; //KEY_LEFT_ON
  if((~GPIOA_IDR) & 0x0080) Key_Status_Now |= 0x20; //KEY_RIGHT_ON
  
  if(Key_Status_Now &(~Key_Status_Last)){
    
    Key_Wait_Counter=25;        //500mSڣԶظ
    
    if(Key_Status_Now & 0x01)  KeyCode=KEYCODE_PLAY; // KeyCode(Play) 
    if(Key_Status_Now & 0x02)  KeyCode=KEYCODE_MANU; // KeyCode(Manu) 
    if(Key_Status_Now & 0x04)  KeyCode=KEYCODE_UP;   // KeyCode(Up) 
    if(Key_Status_Now & 0x08)  KeyCode=KEYCODE_DOWN; // KeyCode(Down) 
    if(Key_Status_Now & 0x10)  KeyCode=KEYCODE_LEFT; // KeyCode(Left) 
    if(Key_Status_Now & 0x20)  KeyCode=KEYCODE_RIGHT;// KeyCode(Right) 
    
  } else {
      
    if(Key_Status_Now & Key_Status_Last){
      if((Key_Wait_Counter | Key_Repeat_Counter)==0){
        
        if(Key_Status_Now & 0x01)  KeyCode=KEYCODE_PLAY; // KeyCode(Play)
        if(Key_Status_Now & 0x02)  KeyCode=KEYCODE_MANU; // KeyCode(Manu) 
        if(Key_Status_Now & 0x04)  KeyCode=KEYCODE_UP;   // KeyCode(Up) 
        if(Key_Status_Now & 0x08)  KeyCode=KEYCODE_DOWN; // KeyCode(Down) 
        if(Key_Status_Now & 0x10)  KeyCode=KEYCODE_LEFT; // KeyCode(Left) 
        if(Key_Status_Now & 0x20)  KeyCode=KEYCODE_RIGHT;// KeyCode(Right)
        
        Key_Repeat_Counter = 3; //ÿ60mSԶظһ
      }
    }else Key_Wait_Counter=25;      //500mSڣԶظ
  }
  Key_Status_Last = Key_Status_Now;
  return KeyCode;
}    
/*******************************************************************************
*  : MSD_WriteByte     ˵ : SDд1ֽ      룺1ֽ
*******************************************************************************/
void MSD_WriteByte(u8 Data)
{
  while (SPI_GetFlagStatus(SPI2, SPI_FLAG_TXE) == RESET);
  SPI_SendData(SPI2, Data);
  while (SPI_GetFlagStatus(SPI2, SPI_FLAG_BSY) == RESET);
}

/*******************************************************************************
*  : MSD_WriteByte     ˵ : SD1ֽ      أ1ֽ
*******************************************************************************/
unsigned char MSD_ReadByte(void)
{
  unsigned char Data = 0;
  while (SPI_GetFlagStatus(SPI2, SPI_FLAG_TXE) == RESET);
  SPI_SendData(SPI2, DUMMY);
  while (SPI_GetFlagStatus(SPI2, SPI_FLAG_RXNE) == RESET);
  Data = SPI_ReceiveData(SPI2);
  return Data;
}

/*******************************************************************************
 Battery_Detect: صѹŵ״̬ 
*******************************************************************************/
void Battery_Detect(void)
{   
  unsigned int vb;
  vb =(123*(*((vu16 *)(ADC1_DR_ADDR+2))))>>10;
  Battery=vb_Sum/64; 
  vb_Sum=vb_Sum+vb-Battery; 
  Update[5]=1;
  if(Battery>360)  
    Item_Index[5]=3;
  else  
    if(Battery>340)  
      Item_Index[5]=2;
    else  
      if(Battery>320)  
        Item_Index[5]=1;
      else  
        Item_Index[5]=0;
}
/*******************************************************************************
 Set_Range: ѹתģ⿪״̬ 
*******************************************************************************/
void Set_Range(char Range)
{   

  switch (Range) {
    case 0://10mV 1/Div   
    case 1://20mV 1/Div   
    case 2://50mV 1/Div   
    case 3://0.1V 1/Div   
      RANGE_A_HIGH(); 
      RANGE_B_HIGH(); 
      RANGE_C_HIGH(); 
      RANGE_D_HIGH(); 
    break;
    case 4://0.2V 1/Divʵ    
    case 5://0.5V 1/Div   
    case 6://1V 1/Div   
      RANGE_A_HIGH(); 
      RANGE_B_HIGH(); 
      RANGE_C_HIGH(); 
      RANGE_D_LOW(); 
    break;
    case 7://2V 1/Div    
    case 8://5V 1/Div
    case 9://10V 1/Div
      RANGE_A_LOW(); 
      RANGE_B_HIGH(); 
      RANGE_C_HIGH(); 
      RANGE_D_LOW(); 
    break;
    case 10://0.2V/Div 20mV 10/Div 
    case 11://0.5V/Div 50mV 10/Div
    case 12://  1V/Div 0.1V 10/Div
      RANGE_A_HIGH(); 
      RANGE_B_LOW(); 
      RANGE_C_HIGH(); 
      RANGE_D_LOW(); 
    break;
    case 13:// 2V/Div 0.2V 10/Div
    case 14:// 5V/Div 0.5V 10/Div
    case 15://10V/Div   1V 10/Div
      RANGE_A_LOW(); 
      RANGE_B_LOW(); 
      RANGE_C_HIGH(); 
      RANGE_D_LOW(); 
    break;
    case 16:// 20V/Div  2V 10/Div
    case 17:// 50V/Div  5V 10/Div
    case 18://100V/Div 10V 10/Div
      RANGE_A_HIGH(); 
      RANGE_B_HIGH(); 
      RANGE_C_LOW(); 
      RANGE_D_LOW(); 
    break;
    default : //Connecte To GND
      RANGE_A_LOW(); 
      RANGE_B_LOW(); 
      RANGE_C_LOW(); 
      RANGE_D_LOW(); 
    break;
  }
}

/*******************************************************************************
 Set_Base: ˮƽɨʱת 
*******************************************************************************/
void Set_Base(char Base)
{   
  TIM1_PSC = Scan_PSC[Base];
  TIM1_ARR = Scan_ARR[Base];
  TIM1_CCR1=(Scan_ARR[Base]+1)/2;
}
/*******************************************************************************
 ADC_Start: ¿ʼADCɨ
*******************************************************************************/
void ADC_Start(void) 
{  
  DMA_CCR1 = 0x00000000;           
  DMA_CMAR1 =(u32)&Scan_Buffer[0];        //趨DMAͨ1
  DMA_CNDTR1 = 0x00001000;         
  DMA_CCR1 |= 0x00000001;                 //¿ʼɨ
}
/*******************************************************************************
 Set_Y_Pos: ѹߵ
*******************************************************************************/
void Set_Y_Pos(unsigned short Y0) 
{  
  switch (Item_Index[1]) {
    case  0  :  TIM2_CCR4 =((240-Y0)*20)/32 +881;  break; 
    case  1  :  TIM2_CCR4 =((240-Y0)*42)/32 +799;  break; 
    case  2  :  TIM2_CCR4 =((240-Y0)*104)/32+566;  break; 
    case  3  :  TIM2_CCR4 =((240-Y0)*207)/32+180;  break; 
    
    case  4  :  TIM2_CCR4 =((240-Y0)*55)/32 +750;  break; 
    case  5  :  TIM2_CCR4 =((240-Y0)*138)/32+439;  break; 
    case  6  :  TIM2_CCR4 =((240-Y0)*275)/32-75;   break; 

    case  7  :  TIM2_CCR4 =((240-Y0)*53)/32 +758;  break; 
    case  8  :  TIM2_CCR4 =((240-Y0)*132)/32+461;  break; 
    case  9  :  TIM2_CCR4 =((240-Y0)*265)/32-37;   break; 
    
    case  10 :  TIM2_CCR4 =((240-Y0)*42)/32 +799;  break; 
    case  11 :  TIM2_CCR4 =((240-Y0)*105)/32+563;  break; 
    case  12 :  TIM2_CCR4 =((240-Y0)*212)/32+161;  break; 
    
    case  13 :  TIM2_CCR4 =((240-Y0)*57)/32 +743;  break; 
    case  14 :  TIM2_CCR4 =((240-Y0)*142)/32+424;  break; 
    case  15 :  TIM2_CCR4 =((240-Y0)*284)/32-109;  break; 
    
    case  16 :  TIM2_CCR4 =((240-Y0)*59)/32 +735;  break; 
    case  17 :  TIM2_CCR4 =((240-Y0)*146)/32+409;  break; 
    case  18 :  TIM2_CCR4 =((240-Y0)*294)/32-146;  break;    
    
    default  :  TIM2_CCR4 =956; break;
  }
}
/*******************************************************************************
 Test_USB_ON: USB״̬
*******************************************************************************/
char Test_USB_ON(void) 
{ 
  if(GPIOB_IDR &0x0400) return 1;
  else  return 0;
}

/*******************************************************************************
 SD_Card_ON: USB״̬
*******************************************************************************/
char SD_Card_ON(void) 
{ 
  if(GPIOD_IDR &0x0400) return 1;
  else  return 0;
}

/******************************** END OF FILE *********************************/
