/******************** (C) COPYRIGHT 2009 e-Design Co.,Ltd. *********************
* File Name: msd.c       Author: bure   Hardware: DS0201V1.1   Version: Ver 1.0
*******************************************************************************/
#include "msd.h"
#include "HW_V1_Config.h"
#include "Function.h"

unsigned char  SectorBuff[512];

/*******************************************************************************
 Delay_us: ʱȴ                              
*******************************************************************************/
void Delay_us(void)
{ u32 dlyCount = 0x100; 
   while(--dlyCount);
}
/*******************************************************************************
 MSD_Init: SDʼ                             ֵ0x00=ɹ0xFF=ʧ 
*******************************************************************************/
u8 MSD_Init(void)
{  u32 i=0;
  SPI_Config();
  MSD_CS_HIGH(); 
  for(i=0; i <10; i++) MSD_WriteByte(DUMMY);  //80ʱӣSDڲʱ 
  return (MSD_GoIdleState());                 //SDΪSPIģʽ
}
/*******************************************************************************
 MSD_WriteBlock: SDд 룺ָ롢дַݳ  ֵ0x00=ɹ 
*******************************************************************************/
u8 MSD_WriteBlock(u8* pBuffer, u32 WriteAddr, u16 NumByteToWrite)
{ u32 i=0; u8 rvalue = MSD_RESPONSE_FAILURE;
  MSD_CS_LOW(); Delay_us();
  MSD_SendCmd(MSD_WRITE_BLOCK, WriteAddr, 0xFF);//CMD24ддַ
  if(!MSD_GetResponse(MSD_RESPONSE_NO_ERROR)){  //SDӦɹR1=0x00
    MSD_WriteByte(DUMMY);                       //8ʱӣSDڲʱ
    MSD_WriteByte(0xFE);                        //ʼ0xFE
    for(i=0; i<NumByteToWrite; i++) {
      MSD_WriteByte(*pBuffer); pBuffer++;
    }
    MSD_ReadByte(); MSD_ReadByte();             //2CRC
    if(MSD_GetDataResponse()==MSD_DATA_OK) rvalue=MSD_RESPONSE_NO_ERROR;
  }
  MSD_CS_HIGH(); MSD_WriteByte(DUMMY);          //8ʱӣSDڲʱ
  return rvalue;
}
/*******************************************************************************
 MSD_ReadBlock: SDȡ 룺ָ롢ȡַݳ ֵ0x00=ɹ 
*******************************************************************************/
u8 MSD_ReadBlock(u8* pBuffer, u32 ReadAddr, u16 NumByteToRead)
{ u32 i = 0; u8 rvalue = MSD_RESPONSE_FAILURE;
  MSD_CS_LOW(); Delay_us();
  MSD_SendCmd(MSD_READ_SINGLE_BLOCK, ReadAddr, 0xFF);//CMD17ȡȡַ
  if (!MSD_GetResponse(MSD_RESPONSE_NO_ERROR)) {     //SDӦɹR1=0x00
    if (!MSD_GetResponse(MSD_START_DATA_SINGLE_BLOCK_READ)) { 
      for (i = 0; i < NumByteToRead; i++) {
        *pBuffer = MSD_ReadByte(); pBuffer++;
      }
      MSD_ReadByte(); MSD_ReadByte();                //2CRC
      rvalue = MSD_RESPONSE_NO_ERROR;//ɹ
    }
  }
  MSD_CS_HIGH(); MSD_WriteByte(DUMMY);               //8ʱӣSDڲʱ
  return rvalue;
}
/*******************************************************************************
 MSD_WriteBuffer: SDд 룺ָ롢дַݳ ֵ0x00=ɹ 
*******************************************************************************/
u8 MSD_WriteBuffer(u8* pBuffer, u32 WriteAddr, u32 NumByteToWrite)
{ u32 i=0, NbrOfBlock=0, Offset=0; u8 rvalue=MSD_RESPONSE_FAILURE;
  NbrOfBlock = NumByteToWrite/BLOCK_SIZE;       //
  MSD_CS_LOW(); Delay_us();
  while(NbrOfBlock --) {
    if(MSD_GetResponse(MSD_RESPONSE_NO_ERROR)){ //SDӦɹR1=0xFF
      return MSD_RESPONSE_FAILURE;
    }
    MSD_WriteByte(DUMMY);                       //8ʱӣSDڲʱ
    MSD_WriteByte(MSD_START_DATA_SINGLE_BLOCK_WRITE);//ʼ0xFE
    for(i=0; i<BLOCK_SIZE; i++){
      MSD_WriteByte(*pBuffer); pBuffer++;
    }
    Offset+=512;
    MSD_ReadByte(); MSD_ReadByte();            //2CRC
    if(MSD_GetDataResponse()==MSD_DATA_OK) {
      rvalue=MSD_RESPONSE_NO_ERROR;            //ɹ
    } else {
      rvalue=MSD_RESPONSE_FAILURE;             //ʧ
    }
  }
  MSD_CS_HIGH(); MSD_WriteByte(DUMMY);         //8ʱӣSDڲʱ
  return rvalue;
}
/*******************************************************************************
 MSD_ReadBuffer: SD 룺ָ롢ȡַݳ ֵ0x00=ɹ 
*******************************************************************************/
u8 MSD_ReadBuffer(u8* pBuffer, u32 ReadAddr, u32 NumByteToRead)
{ u32 i=0, NbrOfBlock=0, Offset=0; u8 rvalue=MSD_RESPONSE_FAILURE;
  NbrOfBlock=NumByteToRead / BLOCK_SIZE;       //
  MSD_CS_LOW(); Delay_us();
  while(NbrOfBlock --){
    MSD_SendCmd (MSD_READ_SINGLE_BLOCK, ReadAddr+Offset, 0xFF);//CMD17ȡȡַ

    if (MSD_GetResponse(MSD_RESPONSE_NO_ERROR)){ //SDӦɹ
      return  MSD_RESPONSE_FAILURE;
    }

    if (!MSD_GetResponse(MSD_START_DATA_SINGLE_BLOCK_READ)){ //SDӦΪ0
      for(i=0; i<BLOCK_SIZE; i++) {
        *pBuffer = MSD_ReadByte(); pBuffer++;
      }
      Offset+=512;
      MSD_ReadByte(); MSD_ReadByte();         //2CRC
      rvalue = MSD_RESPONSE_NO_ERROR;
    } else {
      rvalue = MSD_RESPONSE_FAILURE;
    }
  }
  MSD_CS_HIGH(); MSD_WriteByte(DUMMY);
  return rvalue;
}

/*******************************************************************************
* Function Name  : MSD_GetCSDRegister
* Description    : Read the CSD card register.
*                  Reading the contents of the CSD register in SPI mode
*                  is a simple read-block transaction.
* Input          : - MSD_csd: pointer on an SCD register structure
* Output         : None
* Return         : The MSD Response: - MSD_RESPONSE_FAILURE: Sequence failed
*                                    - MSD_RESPONSE_NO_ERROR: Sequence succeed 
*******************************************************************************/
u8 MSD_GetCSDRegister(sMSD_CSD* MSD_csd)
{
  u32 i = 0;
  u8 rvalue = MSD_RESPONSE_FAILURE;
  u8 CSD_Tab[16];

  /* MSD chip select low */
  MSD_CS_LOW();
  Delay_us();
  
  /* Send CMD9 (CSD register) or CMD10(CSD register) */
  MSD_SendCmd(MSD_SEND_CSD, 0, 0xFF);

  /* Wait for response in the R1 format (0x00 is no errors) */
  if (!MSD_GetResponse(MSD_RESPONSE_NO_ERROR))
  {
    if (!MSD_GetResponse(MSD_START_DATA_SINGLE_BLOCK_READ))
    {
      for (i = 0; i < 16; i++)
      {
        /* Store CSD register value on CSD_Tab */
        CSD_Tab[i] = MSD_ReadByte();
      }
    }
    /* Get CRC bytes (not really needed by us, but required by MSD) */
    MSD_WriteByte(DUMMY);
    MSD_WriteByte(DUMMY);
    /* Set response value to success */
    rvalue = MSD_RESPONSE_NO_ERROR;
  }

  /* MSD chip select high */
  MSD_CS_HIGH();
  /* Send dummy byte: 8 Clock pulses of delay */
  MSD_WriteByte(DUMMY);

  /* Byte 0 */
  MSD_csd->CSDStruct = (CSD_Tab[0] & 0xC0) >> 6;
  MSD_csd->SysSpecVersion = (CSD_Tab[0] & 0x3C) >> 2;
  MSD_csd->Reserved1 = CSD_Tab[0] & 0x03;
  /* Byte 1 */
  MSD_csd->TAAC = CSD_Tab[1] ;
  /* Byte 2 */
  MSD_csd->NSAC = CSD_Tab[2];
  /* Byte 3 */
  MSD_csd->MaxBusClkFrec = CSD_Tab[3];
  /* Byte 4 */
  MSD_csd->CardComdClasses = CSD_Tab[4] << 4;
  /* Byte 5 */
  MSD_csd->CardComdClasses |= (CSD_Tab[5] & 0xF0) >> 4;
  MSD_csd->RdBlockLen = CSD_Tab[5] & 0x0F;
  /* Byte 6 */
  MSD_csd->PartBlockRead = (CSD_Tab[6] & 0x80) >> 7;
  MSD_csd->WrBlockMisalign = (CSD_Tab[6] & 0x40) >> 6;
  MSD_csd->RdBlockMisalign = (CSD_Tab[6] & 0x20) >> 5;
  MSD_csd->DSRImpl = (CSD_Tab[6] & 0x10) >> 4;
  MSD_csd->Reserved2 = 0; /* Reserved */
  MSD_csd->DeviceSize = (CSD_Tab[6] & 0x03) << 10;
  /* Byte 7 */
  MSD_csd->DeviceSize |= (CSD_Tab[7]) << 2;
  /* Byte 8 */
  MSD_csd->DeviceSize |= (CSD_Tab[8] & 0xC0) >> 6;
  MSD_csd->MaxRdCurrentVDDMin = (CSD_Tab[8] & 0x38) >> 3;
  MSD_csd->MaxRdCurrentVDDMax = (CSD_Tab[8] & 0x07);
  /* Byte 9 */
  MSD_csd->MaxWrCurrentVDDMin = (CSD_Tab[9] & 0xE0) >> 5;
  MSD_csd->MaxWrCurrentVDDMax = (CSD_Tab[9] & 0x1C) >> 2;
  MSD_csd->DeviceSizeMul = (CSD_Tab[9] & 0x03) << 1;
  /* Byte 10 */
  MSD_csd->DeviceSizeMul |= (CSD_Tab[10] & 0x80) >> 7;
  MSD_csd->EraseGrSize = (CSD_Tab[10] & 0x7C) >> 2;
  MSD_csd->EraseGrMul = (CSD_Tab[10] & 0x03) << 3;
  /* Byte 11 */
  MSD_csd->EraseGrMul |= (CSD_Tab[11] & 0xE0) >> 5;
  MSD_csd->WrProtectGrSize = (CSD_Tab[11] & 0x1F);
  /* Byte 12 */
  MSD_csd->WrProtectGrEnable = (CSD_Tab[12] & 0x80) >> 7;
  MSD_csd->ManDeflECC = (CSD_Tab[12] & 0x60) >> 5;
  MSD_csd->WrSpeedFact = (CSD_Tab[12] & 0x1C) >> 2;
  MSD_csd->MaxWrBlockLen = (CSD_Tab[12] & 0x03) << 2;
  /* Byte 13 */
  MSD_csd->MaxWrBlockLen |= (CSD_Tab[13] & 0xc0) >> 6;
  MSD_csd->WriteBlockPaPartial = (CSD_Tab[13] & 0x20) >> 5;
  MSD_csd->Reserved3 = 0;
  MSD_csd->ContentProtectAppli = (CSD_Tab[13] & 0x01);
  /* Byte 14 */
  MSD_csd->FileFormatGrouop = (CSD_Tab[14] & 0x80) >> 7;
  MSD_csd->CopyFlag = (CSD_Tab[14] & 0x40) >> 6;
  MSD_csd->PermWrProtect = (CSD_Tab[14] & 0x20) >> 5;
  MSD_csd->TempWrProtect = (CSD_Tab[14] & 0x10) >> 4;
  MSD_csd->FileFormat = (CSD_Tab[14] & 0x0C) >> 2;
  MSD_csd->ECC = (CSD_Tab[14] & 0x03);
  /* Byte 15 */
  MSD_csd->CRC = (CSD_Tab[15] & 0xFE) >> 1;
  MSD_csd->Reserved4 = 1;

  /* Return the reponse */
  return rvalue;
}

/*******************************************************************************
* Function Name  : MSD_GetCIDRegister
* Description    : Read the CID card register.
*                  Reading the contents of the CID register in SPI mode
*                  is a simple read-block transaction.
* Input          : - MSD_cid: pointer on an CID register structure
* Output         : None
* Return         : The MSD Response: - MSD_RESPONSE_FAILURE: Sequence failed
*                                    - MSD_RESPONSE_NO_ERROR: Sequence succeed 
*******************************************************************************/
u8 MSD_GetCIDRegister(sMSD_CID* MSD_cid)
{
  u32 i = 0;
  u8 rvalue = MSD_RESPONSE_FAILURE;
  u8 CID_Tab[16];

  /* MSD chip select low */
  MSD_CS_LOW();
  Delay_us();
  
  /* Send CMD10 (CID register) */
  MSD_SendCmd(MSD_SEND_CID, 0, 0xFF);

  /* Wait for response in the R1 format (0x00 is no errors) */
  if (!MSD_GetResponse(MSD_RESPONSE_NO_ERROR))
  {
    if (!MSD_GetResponse(MSD_START_DATA_SINGLE_BLOCK_READ))
    {
      /* Store CID register value on CID_Tab */
      for (i = 0; i < 16; i++)
      {
        CID_Tab[i] = MSD_ReadByte();
      }
    }
    /* Get CRC bytes (not really needed by us, but required by MSD) */
    MSD_WriteByte(DUMMY);
    MSD_WriteByte(DUMMY);
    /* Set response value to success */
    rvalue = MSD_RESPONSE_NO_ERROR;
  }

  /* MSD chip select high */
  MSD_CS_HIGH();
  /* Send dummy byte: 8 Clock pulses of delay */
  MSD_WriteByte(DUMMY);

  /* Byte 0 */
  MSD_cid->ManufacturerID = CID_Tab[0];
  /* Byte 1 */
  MSD_cid->OEM_AppliID = CID_Tab[1] << 8;
  /* Byte 2 */
  MSD_cid->OEM_AppliID |= CID_Tab[2];
  /* Byte 3 */
  MSD_cid->ProdName1 = CID_Tab[3] << 24;
  /* Byte 4 */
  MSD_cid->ProdName1 |= CID_Tab[4] << 16;
  /* Byte 5 */
  MSD_cid->ProdName1 |= CID_Tab[5] << 8;
  /* Byte 6 */
  MSD_cid->ProdName1 |= CID_Tab[6];
  /* Byte 7 */
  MSD_cid->ProdName2 = CID_Tab[7];
  /* Byte 8 */
  MSD_cid->ProdRev = CID_Tab[8];
  /* Byte 9 */
  MSD_cid->ProdSN = CID_Tab[9] << 24;
  /* Byte 10 */
  MSD_cid->ProdSN |= CID_Tab[10] << 16;
  /* Byte 11 */
  MSD_cid->ProdSN |= CID_Tab[11] << 8;
  /* Byte 12 */
  MSD_cid->ProdSN |= CID_Tab[12];
  /* Byte 13 */
  MSD_cid->Reserved1 |= (CID_Tab[13] & 0xF0) >> 4;
  /* Byte 14 */
  MSD_cid->ManufactDate = (CID_Tab[13] & 0x0F) << 8;
  /* Byte 15 */
  MSD_cid->ManufactDate |= CID_Tab[14];
  /* Byte 16 */
  MSD_cid->CRC = (CID_Tab[15] & 0xFE) >> 1;
  MSD_cid->Reserved2 = 1;

  /* Return the reponse */
  return rvalue;
}

/*******************************************************************************
* Function Name  : MSD_SendCmd
* Description    : Send 5 bytes command to the MSD card.
* Input          : - Cmd: the user expected command to send to MSD card
*                  - Arg: the command argument
*                  - Crc: the CRC
* Output         : None
* Return         : None
*******************************************************************************/
void MSD_SendCmd(u8 Cmd, u32 Arg, u8 Crc)
{ u32 i=0; u8 Frame[6];
  Frame[0] = (Cmd | 0x40);
  Frame[1] = (u8)(Arg >> 24);
  Frame[2] = (u8)(Arg >> 16);
  Frame[3] = (u8)(Arg >> 8);
  Frame[4] = (u8)(Arg);
  Frame[5] = (Crc);
  for (i=0; i<6; i++) MSD_WriteByte(Frame[i]);
}
/*******************************************************************************
* Function Name  : MSD_GetDataResponse
* Description    : Get MSD card data response.
* Input          : None
* Output         : None
* Return         : The MSD status: Read data response xxx0<status>1
*                   - status 010: Data accecpted
*                   - status 101: Data rejected due to a crc error
*                   - status 110: Data rejected due to a Write error.
*                   - status 111: Data rejected due to other error.
*******************************************************************************/
u8 MSD_GetDataResponse(void)
{ u32 i=0; u8 response, rvalue;
  while (i<=64){
    response = MSD_ReadByte();//Read resonse
    response &= 0x1F;//Mask unused bits 
    switch (response){
      case MSD_DATA_OK:
      {
        rvalue = MSD_DATA_OK;
        break;
      }
      case MSD_DATA_CRC_ERROR:
        return MSD_DATA_CRC_ERROR;
      case MSD_DATA_WRITE_ERROR:
        return MSD_DATA_WRITE_ERROR;
      default:
      {
        rvalue = MSD_DATA_OTHER_ERROR;
        break;
      }
    }
    if (rvalue == MSD_DATA_OK)//Exit loop in case of data ok
      break;
    i++;//Increment loop counter
  }
  while (MSD_ReadByte()==0);//Wait null data
  return response;//Return response
}
/*******************************************************************************
* Function Name  : MSD_GetResponse
* Description    : Returns the MSD response.
* Input          : None
* Output         : None
* Return         : The MSD Response: - MSD_RESPONSE_FAILURE: Sequence failed
*                                    - MSD_RESPONSE_NO_ERROR: Sequence succeed 
*******************************************************************************/
u8 MSD_GetResponse(u8 Response)
{ u32 Count=0xFFF;
  while ((MSD_ReadByte()!=Response)&& Count) Count--;//Check if response is got or a timeout is happen
  if (Count==0) return MSD_RESPONSE_FAILURE;//After time out
  else return MSD_RESPONSE_NO_ERROR;//Right response got
}
/*******************************************************************************
* Function Name  : MSD_GetStatus
* Description    : Returns the MSD status.
* Input          : None
* Output         : None
* Return         : The MSD status.
*******************************************************************************/
u16 MSD_GetStatus(void)
{
  u16 Status = 0;

  /* MSD chip select low */
  MSD_CS_LOW();
  Delay_us();
  
  /* Send CMD13 (MSD_SEND_STATUS) to get MSD status */
  MSD_SendCmd(MSD_SEND_STATUS, 0, 0xFF);

  Status = MSD_ReadByte();
  Status |= (u16)(MSD_ReadByte() << 8);

  /* MSD chip select high */
  MSD_CS_HIGH();
  /* Send dummy byte 0xFF */
  MSD_WriteByte(DUMMY);

  return Status;
}

/*******************************************************************************
* Function Name  : MSD_GoIdleState
* Description    : Put MSD in Idle state.
* Input          : None
* Output         : None
* Return         : The MSD Response: - MSD_RESPONSE_FAILURE: Sequence failed
*                                    - MSD_RESPONSE_NO_ERROR: Sequence succeed 
*******************************************************************************/
u8 MSD_GoIdleState(void)
{
  /* MSD chip select low */
  MSD_CS_LOW();
  Delay_us();
  
  /* Send CMD0 (GO_IDLE_STATE) to put MSD in SPI mode */
  MSD_SendCmd(MSD_GO_IDLE_STATE, 0, 0x95);

  /* Wait for In Idle State Response (R1 Format) equal to 0x01 */
  if (MSD_GetResponse(MSD_IN_IDLE_STATE))
  {
    /* No Idle State Response: return response failue */
    return MSD_RESPONSE_FAILURE;
  }
  /*----------Activates the card initialization process-----------*/
  do
  {
    /* MSD chip select high */
    MSD_CS_HIGH();
    /* Send Dummy byte 0xFF */
    MSD_WriteByte(DUMMY);

    /* MSD chip select low */
    MSD_CS_LOW();

    /* Send CMD1 (Activates the card process) until response equal to 0x0 */
    MSD_SendCmd(MSD_SEND_OP_COND, 0, 0xFF);
    /* Wait for no error Response (R1 Format) equal to 0x00 */
  }
  while (MSD_GetResponse(MSD_RESPONSE_NO_ERROR));

  /* MSD chip select high */
  MSD_CS_HIGH();
  /* Send dummy byte 0xFF */
  MSD_WriteByte(DUMMY);

  return MSD_RESPONSE_NO_ERROR;
}

/********************************* END OF FILE ********************************/
