/******************** (C) COPYRIGHT 2009 e-Design Co.,Ltd. *********************
* ļ  : hw_config.c   ļ˵ : ϵͳʼó  Ӳ : DS0501V1.1
*     :         ǰ汾 : Ver 1.0.0.1 Bata     : 2009/05/14    
*******************************************************************************/
#include "stm32f10x_it.h"
#include "hw_config.h"
#include "Global.h"
#include "usb_lib.h"
#include "msd.h"

u32 Mass_Memory_Size;
u32 Mass_Block_Size;
u32 Mass_Block_Count;
sMSD_CSD MSD_csd;
ErrorStatus HSEStartUpStatus;

/*******************************************************************************
*     : Set_System    ˵   : ϵͳʱӼԴʼ
*******************************************************************************/
void Set_System(void)
{
//  GPIO_InitTypeDef GPIO_InitStructure;

  /* SYSCLK, HCLK, PCLK2 and PCLK1 configuration -----------------------------*/   
  RCC_DeInit();               //RCC system reset(for debug purpose)
  RCC_HSEConfig(RCC_HSE_ON);  //Enable HSE
  HSEStartUpStatus = RCC_WaitForHSEStartUp();//Wait till HSE is ready
  if(HSEStartUpStatus == SUCCESS)
  {
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);//Enable Prefetch Buffer
    FLASH_SetLatency(FLASH_Latency_2);//Flash 2 wait state
    RCC_HCLKConfig(RCC_SYSCLK_Div1);  //HCLK = SYSCLK 
    RCC_PCLK2Config(RCC_HCLK_Div1);   //PCLK2 = HCLK 
    RCC_PCLK1Config(RCC_HCLK_Div2);   //PCLK1 = HCLK/2
    RCC_ADCCLKConfig(RCC_PCLK2_Div6); //ADCCLK = PCLK2/6 = 12MHz
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);  //PLLCLK=8MHz*9=72 MHz
    RCC_PLLCmd(ENABLE);//Enable PLL
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET){}//Wait till PLL is ready
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);//Select PLL as system clock source
    while(RCC_GetSYSCLKSource()!=0x08){}//Wait PLL is used as system clock source
  }
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA, ENABLE);//Enable DMA clock
// Enable ADC1, ADC2, GPIOA, GPIOB, GPIOC, GPIOD, GPIOE, TIM1, AFIO and SPI1 clocks 
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1 | RCC_APB2Periph_ADC2 
       | RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC 
       | RCC_APB2Periph_GPIOD | RCC_APB2Periph_GPIOE | RCC_APB2Periph_AFIO 
       | RCC_APB2Periph_TIM1 | RCC_APB2Periph_SPI1, ENABLE);
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2 | RCC_APB1Periph_TIM3 
       | RCC_APB1Periph_TIM4, ENABLE);//TIM2,TIM3,TIM4  clocks enable

  RCC_USBCLKConfig(RCC_USBCLKSource_PLLCLK_1Div5);//USBCLK = PLLCLK/1.5=48MHz
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_USB, ENABLE);//Enable USB clock
  
}
/*******************************************************************************
*     : NVIC_Configuration   ˵   : жʸʼ
*******************************************************************************/
void NVIC_Configuration(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;
//  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);//Vector Table base at 0x08000000
  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x3000);//Vector Table base at 0x08003000

  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);//NVIC_PriorityGroup_2?

  NVIC_InitStructure.NVIC_IRQChannel = USB_LP_CAN_RX0_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  
  NVIC_InitStructure.NVIC_IRQChannel = USB_HP_CAN_TX_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  /* enabling TIM1 interrupt */
  NVIC_InitStructure.NVIC_IRQChannel=TIM1_CC_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  /* enabling DMA interrupt */
  NVIC_InitStructure.NVIC_IRQChannel=DMAChannel2_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  NVIC_SystemHandlerPriorityConfig(SystemHandler_SysTick, 2, 0);
  /* enabling TIM2 interrupt */
  NVIC_InitStructure.NVIC_IRQChannel=TIM2_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
}

/*******************************************************************************
*     : GPIO_Config   ˵   : GPIO˿ڳʼ
*******************************************************************************/
void GPIO_Config(void)
{
  GPIOA_CRL = 0xBBB04101;  /* GPIOA Bit0-7 ״̬
                |||||||+----- Bit0  nRE  10MHz
                ||||||+------ Bit1  Ain  ģ
                |||||+------- Bit2  CLR  10MHz  
                ||||+-------- Bit3  OK   迹  
                |||+--------- Bit4  Vb   ģ  
                ||+---------- Bit5  SCK  50MHzû  
                |+----------- Bit6  MISO 50MHzû  
                +------------ Bit7  MOSI 50MHzû*/  
  GPIOA_CRH = 0x4444444B;  /* GPIOA Bit8-15 ״̬
                |||||||+----- Bit8  CP   50MHzû(MCO)
                ||||||+------ Bit9  NC   迹
                |||||+------- Bit10 NC   迹  
                ||||+-------- Bit11 D-   迹  
                |||+--------- Bit12 D+   迹  
                ||+---------- Bit13 TMS  迹  
                |+----------- Bit14 TCK  迹  
                +------------ Bit15 TDI  迹*/  
  GPIOB_CRL = 0x3434441B;  /* GPIOB Bit0-7 ״̬
                |||||||+----- Bit0  V0   50MHzû(PWM)
                ||||||+------ Bit1  SDCS 10MHz(V1.0 SDDT 迹)
                |||||+------- Bit2  BT1  迹  
                ||||+-------- Bit3  TDO  迹  
                |||+--------- Bit4  TRST 迹  
                ||+---------- Bit5  nCS  50MHz  
                |+----------- Bit6  NC   迹  
                +------------ Bit7  nRD  50MHz*/  
  GPIOB_CRH = 0x84111111;  /* GPIOB Bit8-15 ״̬
                |||||||+----- Bit8  nWE  10MHz
                ||||||+------ Bit9  CLS  10MHz
                |||||+------- Bit10 A    10MHz  
                ||||+-------- Bit11 B    10MHz  
                |||+--------- Bit12 C    10MHz  
                ||+---------- Bit13 D    10MHz  
                |+----------- Bit14 Vusb 迹  
                +------------ Bit15 KD   */  
  GPIOB_BSRR = GPIO_Pin_15;  //KDΪ
  GPIOC_CRL = 0x33333333;   //GPIOC Bit0-7 迹루LCD_DB0-7
  GPIOC_CRH = 0x33333333;   //GPIOC Bit8-15 迹루LCD_DB8-15
  GPIOD_CRL = 0x44434443;  /* GPIOD Bit0-7 ״̬
                |||||||+----- Bit0  RS   50MHz
                ||||||+------ Bit1  NC   迹
                |||||+------- Bit2  NC   迹  
                ||||+-------- Bit3  NC   迹  
                |||+--------- Bit4  nWR  50MHz  
                ||+---------- Bit5  NC   迹  
                |+----------- Bit6  NC   迹  
                +------------ Bit7  NC   迹*/  
  GPIOD_CRH = 0xB4444481;  /* GPIOD Bit8-15 ״̬
                |||||||+----- Bit8  BL   10MHz
                ||||||+------ Bit9  KM   
                |||||+------- Bit10 NC   迹  
                ||||+-------- Bit11 NC   迹  
                |||+--------- Bit12 NC   迹  
                ||+---------- Bit13 NC   迹  
                |+----------- Bit14 NC   迹  
                +------------ Bit15 WAVE 50MHzò*/  
  GPIOD_BSRR = GPIO_Pin_9;   //KMΪ
  GPIOE_CRL = 0x44444444;   //GPIOE Bit0-7 迹루RAM_DB0-7
  GPIOE_CRH = 0x48814818;  /* GPIOE Bit8-15 ״̬
                |||||||+----- Bit8  KU   
                ||||||+------ Bit9  PD   10MHz
                |||||+------- Bit10 KL     
                ||||+-------- Bit11 SDDT 迹(V1.0 SDCS 10MHz)  
                |||+--------- Bit12 SDPW 10MHz  
                ||+---------- Bit13 KR     
                |+----------- Bit14 KP     
                +------------ Bit15 NC*/ 
  GPIOE_BSRR = GPIO_Pin_8;   //KUΪ
  GPIOE_BSRR = GPIO_Pin_10;  //KLΪ
  GPIOE_BSRR = GPIO_Pin_13;  //KRΪ
  GPIOE_BSRR = GPIO_Pin_14;  //KPΪ
  
  AFIO_MAPR = 0x00001000;  /* AFIOӳĴ Bit0-31 ״̬
                |||||+++----- Ϊλֵ
                ||||+-------- Bit12  TIM4_CH4 ӳ PD15
                ++++--------- Ϊλֵ */ 
  //RCC_MCOConfig(RCC_MCO_SYSCLK);        //MCOϵͳʱ:72MHz
  //RCC_MCOConfig(RCC_MCO_PLLCLK_Div2);   //MCO1/2ϵͳʱ:36MHz
}

/*******************************************************************************
*     : Get_Medium_Characteristics   ˵   : ȡmicroSD
*******************************************************************************/
void Get_Medium_Characteristics(void)
{
  u32 temp1 = 0;
  u32 temp2 = 0;

  MSD_GetCSDRegister(&MSD_csd);

  temp1 = MSD_csd.DeviceSize + 1;
  temp2 = 1 << (MSD_csd.DeviceSizeMul + 2);

  Mass_Block_Count = temp1 * temp2;

  Mass_Block_Size =  1 << MSD_csd.RdBlockLen;

  Mass_Memory_Size = (Mass_Block_Count * Mass_Block_Size);

}
/*******************************************************************************
* Function Name  : SPI_Config   ˵   : SPIʼ
*******************************************************************************/
void SPI_Config(void)
{
//  GPIO_InitTypeDef  GPIO_InitStructure;
  SPI_InitTypeDef   SPI_InitStructure;

  /* SPI1 Config */
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4;
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  SPI_InitStructure.SPI_CRCPolynomial = 7;
  SPI_Init(SPI1, &SPI_InitStructure);
  
  SPI_Cmd(SPI1, ENABLE);/* SPI1 enable */
}
/*******************************************************************************
*     : DMAx_configuration    ˵   : DMAͨʼ
*******************************************************************************/
void DMAx_Configuration(void)
{
//--------------------- DMA channel1 configuration -------------------------//
  DMA_ISR = 0x00000000;/*DMAж״̬ĴͨIFCRӦλ
              |||||||+---GIF1 =0ͨ1ûTEHTTC¼ȫжϱ־
              |||||||+---TCIF1=0ͨ1ûжϱ־
              |||||||+---HTIF1=0ͨ1û봫жϱ־
              |||||||+---TEIF1=0ͨ1ûжϱ־
              ||||||+----ͨ2жϱ־
              ||||++-----ͨ3жϱ־
              ||||++-----ͨ4жϱ־
              |||+-------ͨ5жϱ־
              ||+--------ͨ6жϱ־ 
              ||+--------ͨ7жϱ־ 
              +----------*/
  DMA_IFCR= 0x00000000;/*DMAжϱ־Ĵû
              |||||||+---CGIF1 =1ͨ1TEHTTC¼ȫжϱ־
              |||||||+---CTCIF1=1ͨ1Ĵжϱ־
              |||||||+---CHTIF1=1ͨ1İ봫жϱ־
              |||||||+---CTEIF1=1ͨ1Ĵжϱ־
              ||||||+----ͨ2жϱ־
              ||||++-----ͨ3жϱ־
              ||||++-----ͨ4жϱ־
              |||+-------ͨ5жϱ־
              ||+--------ͨ6жϱ־ 
              ||+--------ͨ7жϱ־ 
              +----------*/
  DMA_CCR1=  0x00003580;/*0011 0101 1000 0000  
               ||||       |||| |||| |||| |||+--EN = 0ͨرգ1ͨ
               ||||       |||| |||| |||| ||+---TCIE=0ж
               ||||       |||| |||| |||| |+----HTIE=0ֹ봫ж
               ||||       |||| |||| |||| +-----TEIE=0ֹж
               ||||       |||| |||| |||+-------DIR =0ݴ䷽򣨴
               ||||       |||| |||| ||+--------CIRC=0ִѭ
               ||||       |||| |||| |+---------PINC=0ִַģʽ 
               ||||       |||| |||| +----------MINC=1ִд洢ַģʽ
               ||||       |||| ||++------------PSIZE=0116λݿ
               ||||       |||| ++--------------MSIZE=0116λ洢ݿ
               ||||       ||++-----------------PL=11ͨȼ
               ||||       |+-------------------MEM2MEM=0Ǵ洢洢ģʽ
               ++++-------+--------------------*/
  DMA_CNDTR1=0x00001000;//DMAͨ1Ĵ(1024*2 Bytes)  
  DMA_CPAR1 = ADC1_DR_ADDR; //DMAͨ1ݼĴַ RAM_DATA_ADDR;
  DMA_CMAR1 =(u32)&Scan_Buffer[0];//DMAͨ1ԴĿĴ洢ַ
  DMA_CCR1 |= 0x00000001;// EN = 1DMAͨ1 

  DMA_CCR2=  0x00003580;/*0011 0101 1000 0000  
               ||||       |||| |||| |||| |||+--EN = 0ͨرգ=1ͨ
               ||||       |||| |||| |||| ||+---TCIE=0ж
               ||||       |||| |||| |||| |+----HTIE=0ֹ봫ж
               ||||       |||| |||| |||| +-----TEIE=0ֹж
               ||||       |||| |||| |||+-------DIR =0ݴ䷽򣨴
               ||||       |||| |||| ||+--------CIRC=0ִѭ
               ||||       |||| |||| |+---------PINC=0ִַģʽ 
               ||||       |||| |||| +----------MINC=1ִд洢ַģʽ
               ||||       |||| ||++------------PSIZE=0116λݿ
               ||||       |||| ++--------------MSIZE=0116λ洢ݿ
               ||||       ||++-----------------PL=11ͨȼ
               ||||       |+-------------------MEM2MEM=0Ǵ洢洢ģʽ
               ++++-------+--------------------*/
  DMA_CNDTR2=0x00001000;//DMAͨ2Ĵ(1024*2 Bytes)  
  DMA_CPAR2 =(TIM3_BASE+0x24);//RAM_DATA_ADDR;    //DMAͨ2ݼĴַ
  DMA_CMAR2 =(u32)&Scan_Buffer[0];//DMAͨ2ԴĿĴ洢ַ
//  DMA_CCR2 |= 0x00000001;// EN = 1DMAͨ2 
}
/*******************************************************************************
*     : ADC_configuration  ˵  : ADCʼADCɺԶDMA
*******************************************************************************/
void ADC_Configuration(void)
{
  /*--------------------------- ADC1 configuration ---------------------------*/
  ADC2_CR1 =0x00000000;
  ADC1_CR1 =0x00000000;/*
              ||||||++---AWDCH[4:0]ģ⿴Źͨѡλ 
              ||||||+----=000EOCAWDJEOCж
              |||||+-----Bit8_SCAN=0ʹɨģʽ
              ||||++-----ָλֵ
              |||+-------DUALMOD=0ģʽ
              ||+--------ͨעͨģ⿴Ź 
              ++---------*/
  ADC2_CR2 =0x00100000;
  ADC1_CR2 =0x00100100;/*
              |||||||+---ADON=0رADCת/У׼=1ADCת
              |||||||+---CONT=01תģʽ
              |||||||+---CAL=0=1A/DУʼ׼У׼λӲ
              |||||||+---RSTCAL=0=1ʼУ׼ĴУ׼λӲ
              ||||||+----
              |||||+-----ALIGN=0 & DMA=1ҶʹDMAģʽ
              ||||+------
              |||+-------=0000ͨʹöʱ1CC1¼ת=1110SWSTART
              ||+--------=1ʹⲿźת 
              ++---------*/
  ADC2_SQR1=0x00000000;
  ADC1_SQR1=0x00000000;/*ADCмĴ 1
              ||++++++---SQ13-16=00000תе13-16תͨ(5Bits*4)
              ++---------*/
  ADC2_SQR3 =0x00000004;
  ADC1_SQR3 =0x00000001;/*ADCмĴ 3
               ||||||++---SQ1=00001תеĵ1תͨı(1)
               +++++++----SQ2-6=00000תе2-6תͨ(5Bits*5)
               +----------*/
  ADC2_SMPR2=0x00001000;
  ADC1_SMPR2=0x00000008;/*ADCʱĴ 1
               |||||||+---SMP01=001(3Bits)ʹͨ01Ĳʱ 7.5T
               ||||+------SMP04=001(3Bits)ʹͨ04Ĳʱ 7.5T
               |+++++++---SMP11-17=000(3Bits*7)ͨ11-17Ĳʱ 1.5T
               ++---------*/
  ADC1_CR2 |=0x00000001; ADC2_CR2 |=0x00000001;//ADON=1ADC1ADC2
  ADC1_CR2 |=0x00000008; while(ADC1_CR2 & 0x00000008);//ʼADC1У׼Ĵ
  ADC2_CR2 |=0x00000008; while(ADC2_CR2 & 0x00000008);//ʼADC2У׼Ĵ
  ADC1_CR2 |=0x00000004; while(ADC1_CR2 & 0x00000004);//ADC1У׼
  ADC2_CR2 |=0x00000004; while(ADC2_CR2 & 0x00000004);//ADC2У׼
}
/*******************************************************************************
*  : TIM1_configuration    ˵ : TIM1ڶʱADC
*******************************************************************************/
void TIM1_Configuration(void)
{
  TIM1_PSC = Scan_PSC[Item_Index[2]];//OC1źDMAԼ120nSӳ
  TIM1_ARR = Scan_ARR[Item_Index[2]];//
  TIM1_CCR1 = Scan_CCR1[Item_Index[2]] ;//ȣռձԼ25%
  TIM1_CR1 = 0x0094;/*0000 0000 1001 0100  
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA 
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ 
                      |||| |||| |||+--------DIR=1¼
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM1_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
/*  TIM1_CR2 = 0x0008;0000 0000 0000 1000  
                      ++++ ++++ ++++ |+++---Ϊλֵ
                                     +------CCDS=1ʱͳCCxDMA */
  TIM1_RCR = 0x0000;/*0000 0000 0000 0001  
                      |||| |||| ++++ ++++---ڱضģʽ£PWMڵĿ+1
                      ++++-++++-------------*/
  TIM1_CCER =0x0001;/*0000 0000 0000 0001  
                      |||| |||| |||| |||+---CC1E=1OC1źӦ
                      |||| |||| |||| ||+----CC1P=0OC1ߵƽЧ
                      |||| |||| |||| |+-----CC1NE=0OC1Nֹ
                      |||| |||| |||| +------CC1NP=0OC1NߵƽЧ
                      ++++-++++-++++--------CC2CC3CC4Ϊλֵ*/
  TIM1_CCMR1=0x0078;/*0000 0000 0111 1100  
                      |||| |||| |||| ||++---CC1S=00CC1ͨΪ
                      |||| |||| |||| |+-----OC1FE=1Ƚ1 ʹܣ
                      |||| |||| |||| +------OC1PE=1Ƚ1Ԥװʹ 
                      |||| |||| |+++--------0C1M=111PWMģʽ2
                      |||| |||| +-----------OC1CE=0OC1REF ETRFӰ
                      ++++-++++-------------CC2ͨΪλֵ*/
  TIM1_BDTR =0x8000;/*1000 0000 0000 0000  
                      |+++-++++-++++-++++---λֲ 
                      +---------------------MOE=0ʹ*/
  TIM1_DIER =0x4200;/*0100 0011 0000 0000  DMAжʹܼĴ
                       |     ||        +----CC1IE=0/Ƚ1ж
                       |     |+-------------UDE=1µDMA
                       |     +--------------CC1DE=1/Ƚ1DMA
                       +--------------------TDE=1DMA*/
  TIM1_CR1 |=0x0001;//CEN=1ʹTIMER1 
}
/*******************************************************************************
*  : TIM2_configuration    ˵ : TIM2ڴжϣϵͳڲʱ
*******************************************************************************/
void TIM2_Configuration(void)
{
  TIM2_PSC =9; 
  TIM2_ARR =7199;//1mS =PSC+1ARR+1/72MHz/2uS
  TIM2_CCR1 =3600; //ȣռձȣ50%
  TIM2_CR1 = 0x0084;/*0000 0000 1000 0100  
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA 
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ 
                      |||| |||| |||+--------DIR=0ϼ
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM1_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM2_DIER =0x0002;/*0000 0000 0000 0010  DMAжʹܼĴ
                             |         +----CC1IE=1/Ƚ1ж
                             +--------------CC1DE=1/Ƚ1DMA*/
  TIM2_CR1 |=0x0001;//CEN=1ʹTIMER2 
}
/*******************************************************************************
*  : TIM3_configuration    ˵ : TIM3_CH3PWMYͨƫƵѹֵ
*******************************************************************************/
void TIM3_Configuration(void)
{
  TIM3_PSC =0;  
  TIM3_ARR =959;          //72MHz/960=75KHz
  TIM3_CCR3 =360-30+v0;  //(30*v0)/16(v0-MIN_Y)*2; //ȣĳʼֵ
  TIM3_CR1 = 0x0084;/*0000 0000 1000 0100  
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA 
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ 
                      |||| |||| |||+--------DIR=0ϼ
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM3_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM3_CCER =0x0300;/*0000 0011 0000 0000  
                      ++++-||||-++++-++++---CC1CC2CC4Ϊλֵ
                           |||+-------------CC3E=1OC3źӦ
                           ||+--------------CC3P=1OC3͵ƽЧ
                           |+---------------CC3NE=0OC3Nֹ
                           +----------------CC3NP=0OC3NߵƽЧ*/
  TIM3_CCMR2=0x007C;/*0000 0000 0111 1100  
                      |||| |||| |||| ||++---CC3S=00CC3ͨΪ
                      |||| |||| |||| |+-----OC3FE=1Ƚ3 ʹܣ
                      |||| |||| |||| +------OC3PE=1Ƚ3Ԥװʹ 
                      |||| |||| |+++--------0C3M=111PWMģʽ2
                      |||| |||| +-----------OC3CE=0OC3REF ETRFӰ
                      ++++-++++-------------CC4ͨΪλֵ*/
  TIM3_DIER =0x0000;/*0000 0000 0000 0000   DMAжʹܼĴ
                           |         +-- ---CC3IE=0/Ƚ3ж
                           +----------------CC3DE=0/Ƚ3DMA*/
  TIM3_CR1 |=0x0001;//CEN=1ʹTIMER3 
}
/*******************************************************************************
*  : TIM4_configuration    ˵ : TIM4_CH4ѡƵʵı׼
*******************************************************************************/
void TIM4_Configuration(void)
{
  TIM4_PSC = 7;
  TIM4_ARR = Fout_ARR[Item_Index[11]];        //
  TIM4_CCR4 = (Fout_ARR[Item_Index[11]]+1)/2; //0.5mSռձԼ50%
  TIM4_CR1 = 0x0084;/*0000 0000 1000 0100  
                      |||| |||| |||| |||+---CEN=0ֹ
                      |||| |||| |||| ||+----UDIS=0UEV
                      |||| |||| |||| |+-----URS=1ֻмжϻDMA 
                      |||| |||| |||| +------OPM=0ڷ¼ʱֹͣ 
                      |||| |||| |||+--------DIR=0ϼ
                      |||| |||| |++---------CMS=00ѡضģʽ
                      |||| |||| +-----------ARPE=1TIM3_ARRĴװ뻺
                      |||| ||++-------------CKD=00,CK_INTƵΪ1
                      ++++-++---------------*/
  TIM4_CCER =0x1000;/*0001 0000 0000 0000  
                      |||| ++++-++++-++++---CC1CC2CC3Ϊλֵ
                      |||+------------------CC4E=1OC4źӦ
                      ||+-------------------CC4P=0OC4ߵƽЧ
                      |+--------------------CC4NE=0OC4Nֹ
                      +---------------------CC4NP=0OC4NߵƽЧ*/
  TIM4_CCMR2=0x7C00;/*0111 1100 0000 0000  
                      |||| |||| ++++-++++---CC3ͨΪλֵ
                      |||| ||++-------------CC4S=00CC4ͨΪ
                      |||| |+---------------OC4FE=1Ƚ4 ʹܣ
                      |||| +----------------OC4PE=1Ƚ4Ԥװʹ 
                      |+++------------------0C4M=111PWMģʽ2
                      +---------------------OC4CE=0OC4REF ETRFӰ*/
  TIM4_DIER =0x0000;/*0000 0000 0000 0000   DMAжʹܼĴ
                         |         +--------CC4IE=0/Ƚ3ж
                         +------------------CC4DE=0/Ƚ3DMA*/
  TIM4_CR1 |=0x0001;//CEN=1ʹTIMER4 
}

/******************************** END OF FILE *********************************/
